#define FSR_SHRINK 0.00015

class Fsr
{
  private:
  double value;
  double max;
  double min;
  public:
  Fsr();
  double getNormalized();
  void setAnalog(int an);
};

Fsr::Fsr( )
{
  value = 0;
  max = 1;
  min = 1024;
}

double Fsr::getNormalized()
{
  return value;
}

void Fsr::setAnalog(int an)
{
  double delta = 0;
  //detecting the max/min
  if(an>max) max = an;
  else if(an<min) min = an;
  //shrinking the interval
  delta = (max-min)*FSR_SHRINK;
  max -= delta;
  min += delta;
  value = ((double)an-min)/(max-min);

#ifdef   FSR_MONITOR
  Serial.print(min,DEC);
  Serial.print(" - ");
  Serial.print(max,DEC);
  Serial.print(" - ");
  Serial.print(value*1000,DEC);
  Serial.print(" | ");
#endif
 
}


Fsr fsr1R,fsr2R,fsr3R,fsr1L,fsr2L,fsr3L;

/*
double fsrNorm1L(int an)
{
  static double max = 1;
  static double min = 1024;
  double delta = 0;
  //detecting the max/min
  if(an>max) max = an;
  else if(an<min) min = an;
  //shrinking the interval
  delta = (max-min)*FSR_SHRINK;
  max -= delta;
  min += delta;
  Serial.print(min,DEC);
  Serial.print(" - ");
  Serial.print(max,DEC);
  Serial.print(" - ");
  Serial.print(((double)an-min)/(max-min)*1000,DEC);
  return ((double)an-min)/(max-min);
}

double fsrNorm2L(int an)
{
  static double max = 1;
  static double min = 1024;
  double delta = 0;
  //detecting the max/min
  if(an>max) max = an;
  else if(an<min) min = an;
  //shrinking the interval
  delta = (max-min)*FSR_SHRINK;
  max -= delta;
  min += delta;
  Serial.print(min,DEC);
  Serial.print(" - ");
  Serial.print(max,DEC);
  Serial.print(" - ");
  Serial.print(((double)an-min)/(max-min)*1000,DEC);
  return ((double)an-min)/(max-min);
}

double fsrNorm3L(int an)
{
  static double max = 1;
  static double min = 1024;
  double delta = 0;
  //detecting the max/min
  if(an>max) max = an;
  else if(an<min) min = an;
  //shrinking the interval
  delta = (max-min)*FSR_SHRINK;
  max -= delta;
  min += delta;
  Serial.print(min,DEC);
  Serial.print(" - ");
  Serial.print(max,DEC);
  Serial.print(" - ");
  Serial.print(((double)an-min)/(max-min)*1000,DEC);
  return ((double)an-min)/(max-min);
}

double fsrNorm1R(int an)
{
  static double max = 1;
  static double min = 1024;
  double delta = 0;
  //detecting the max/min
  if(an>max) max = an;
  else if(an<min) min = an;
  //shrinking the interval
  delta = (max-min)*FSR_SHRINK;
  max -= delta;
  min += delta;
  Serial.print(min,DEC);
  Serial.print(" - ");
  Serial.print(max,DEC);
  Serial.print(" - ");
  Serial.print(((double)an-min)/(max-min)*1000,DEC);
  return ((double)an-min)/(max-min);
}


double fsrNorm2R(int an)
{
  static double max = 1;
  static double min = 1024;
  double delta = 0;
  //detecting the max/min
  if(an>max) max = an;
  else if(an<min) min = an;
  //shrinking the interval
  delta = (max-min)*FSR_SHRINK;
  max -= delta;
  min += delta;
  Serial.print(min,DEC);
  Serial.print(" - ");
  Serial.print(max,DEC);
  Serial.print(" - ");
  Serial.print(((double)an-min)/(max-min)*1000,DEC);
  return ((double)an-min)/(max-min);
}

double fsrNorm3R(int an)
{
  static double max = 1;
  static double min = 1024;
  double delta = 0;
  //detecting the max/min
  if(an>max) max = an;
  else if(an<min) min = an;
  //shrinking the interval
  delta = (max-min)*FSR_SHRINK;
  max -= delta;
  min += delta;
  Serial.print(min,DEC);
  Serial.print(" - ");
  Serial.print(max,DEC);
  Serial.print(" - ");
  Serial.print(((double)an-min)/(max-min)*1000,DEC);
  return ((double)an-min)/(max-min);
}
*/
