static double forceLPidH()
{
  //high
  //static double Kp = 20.0;
  //static double Ki = 50.0;
  //static double Kd = 2.0;///
  
  //normal
  static double Kp = 8.0;
  static double Ki = 5.0;
  static double Kd = 0.5;
  


  static double ei = 0;
  static double err, ed, prev_err, prev_u;
  static double u = 0;

  double alpha = 0.9;
  
  //manual tune
  //Kp = (float)(anValue[2]/10.0F);
  //Ki = (double)anValue[2]/10.0F;
  //Kd = (double)anValue[2]/10.0F;
  //alpha =((double)anValue[3])/1024.0;


  err = (forceL_ref - forceL);
  ei += windupL?0:err*Ts;
  ed = 0.8*ed + 0.2*(err-prev_err)/Ts;

  u = 0.95*u + 0.05*(Kp * err + Ki * ei + Kd * ed);
 
  
  //u = prev_u + anValue[2]*0.1*err/(pow(len-0.594,2)*0.1665);

  prev_err = err;
  prev_u = u;
  return u;
}

static double forcePidL()
{
   
  //normal
  //static double Kp = 8.0;
  //static double Ki = 5.0;
  //static double Kd = 0.5;
  
  //very low
/*  static double Kp = 2.5;
  static double Ki = 1.0;
  static double Kd = 0.2;
  */
  
  static double Kp = 2.0;
  static double Ki = 0.8;
  static double Kd = 0.15;

  static double ei = 0;
  static double err, ed, prev_err, prev_u;
  static double u = 0;

  double alpha = 0.9;
  
  err = (forceL_ref - forceL);
  ei += windupL?0:err*Ts;
  ed = 0.8*ed + 0.2*(err-prev_err)/Ts;

  u = 0.95*u + 0.05*(Kp * err + Ki * ei + Kd * ed);
 
  prev_err = err;
  prev_u = u;
  return u;
}

static double forcePidR()
{
   
  //normal
  //static double Kp = 8.0;
  //static double Ki = 5.0;
  //static double Kd = 0.5;
  
  //very low
/*  static double Kp = 2.5;
  static double Ki = 1.0;
  static double Kd = 0.2;
*/
  static double Kp = 2.0;
  static double Ki = 0.8;
  static double Kd = 0.15;

  static double ei = 0;
  static double err, ed, prev_err, prev_u;
  static double u = 0;

  double alpha = 0.9;
  
  err = (forceR_ref - forceR);
 
  ei += windupR?0:err*Ts;
  ed = 0.8*ed + 0.2*(err-prev_err)/Ts;

  u = 0.95*u + 0.05*(Kp * err + Ki * ei + Kd * ed);
 
  prev_err = err;
  prev_u = u;
  return u;
}

static double forceLPidB()
{
  static double Kp = 0.001;
  static double Ti = 0.001;
  static double Td = 0.001;

  static double e[3] = {
    0,0,0  };
  static double u[3] = {
    0,0,0  };

  static int k = 2;

  const double a = Kp*(1 + 0.5*Ts/Ti + 2*Td/Ts);
  const double b = Kp*(Ts/Ti - 4*Td/Ts);
  const double c = Kp*(1 - 0.5*Ts/Ti - 2*Td/Ts);

  e[k] = (forceL_ref - forceL);
  u[k] = a*e[k] + b*e[(k-1)%3] + c*e[(k-2)%3] + u[(k-2)%3];
  


  k++;
  k = k%3;

  return 0.93*u[k] + 0.03*u[k-1];
//  return ;
}

double e(int k)
{
  static double e[3] = {
    0,0,0  };
  return e[k%3];
}

static long anglePid()
{
  static double Kp = 50.0F;
  static double Ki = 0.0F;
  static double Kd = 0.0F;

  static double ei = 0;
  static double err, ed, prev_err;
  static double u = 0;

  //manual tune
  //Kp = (float)(anValue[3]/10.0F);
  //Ki = 10.0F + (float)(anValue[2]/10.0F);
  //Kd = 10.0F + (float)(anValue[3]/100.0F);


  err = (thetaL_ref - thetaL);
  ei += windupL?0:err*Ts;
  ed = (err-prev_err)/Ts;

  u = 0.97*u + 0.03*(Kp * err + Ki * ei + Kd * ed);
 
  prev_err = err;
  return u;
}

