//rtc
double time = 0;

static int settlement = 0;
static int i,j,k,kp,ki,kd;



void process() {

  //reset
  if(settlement)
  {
    pressureL = 0;
    if(time<2) settlement = 0;
  }
  else
  {

    //**** INPUT *******  

    // todo oversampling in the ISR?  
    // read the analog in value:
    anValue[0] = analogRead(anInPin0);
    anValue[1] = analogRead(anInPin1);
    anValue[2] = analogRead(anInPin2);
    anValue[3] = analogRead(anInPin3);
    anValue[4] = analogRead(anInPin4);
    anValue[5] = analogRead(anInPin5);
    anValue[6] = analogRead(anInPin6);
    anValue[7] = analogRead(anInPin7);
    anValue[8] = analogRead(anInPin8);
    anValue[9] = analogRead(anInPin9);
    anValue[10] = analogRead(anInPin10);
    anValue[11] = analogRead(anInPin11);
    anValue[12] = analogRead(anInPin12);
    anValue[13] = analogRead(anInPin13);
    anValue[14] = analogRead(anInPin14);
    anValue[15] = analogRead(anInPin15);

    //------- INPUTS ------------------------------------
    
    tune0 = (double)++anValue[9]/1024;
    tune1 = (double)++anValue[13]/1024;
    tune2 = (double)++anValue[2]/1024;
    tune3 = (double)++anValue[3]/1024;
    tune4 = (double)++anValue[2]/1024;
    tune5 = (double)++anValue[3]/1024;    

    //todo
    pressureL = anValue[5];
    pressureR = anValue[4];
    
    forceL = FLfilter01(anValue[14]) - 51;
    forceR = FRfilter01(anValue[15]) - 51;
    
    //forceL = anValue[14];
    //forceR = anValue[15];

    thetaL = anValue[1]-442-156;
    thetaR = -(anValue[0]-749+10+200);
    dthetaL = (thetaL - _thetaL)*60/PROC_DURATION;
    dthetaR = (thetaR - _thetaR)*60/PROC_DURATION;
    
    _thetaL = thetaL;
    _thetaR = thetaR;
   
 
    /*
    fsr1L = fsrNorm1L(1023-anValue[7]);//tacco      
    fsr2L = fsrNorm2L(1023-anValue[6]);//medio      
    fsr3L = fsrNorm3L(1023-anValue[8]);//punta          
    
    fsr1R = fsrNorm1R(1023-anValue[11]);      
    fsr2R = fsrNorm2R(1023-anValue[10]);      
    fsr3R = fsrNorm3R(1023-anValue[12]);              
    */
  
    fsr1L.setAnalog(1023-anValue[6]);//tacco        
    fsr2L.setAnalog(1023-anValue[7]);//medio            
    fsr3L.setAnalog(1023-anValue[8]);//punta  
  
    fsr1R.setAnalog(1023-anValue[10]);//tacco       
    fsr2R.setAnalog(1023-anValue[11]);//medio            
    fsr3R.setAnalog(1023-anValue[12]);//punta  

    fsrL = 0.5*fsr1L.getNormalized() + fsr3L.getNormalized() + fsr2L.getNormalized();
    fsrR = 0.5*fsr1R.getNormalized() + fsr3R.getNormalized() + fsr2R.getNormalized();
    
   
    //filter
    //float kf = tune2;
    //fsrL = kf*fsrL + (1-kf)*_fsrL;
    //fsrR = kf*fsrR + (1-kf)*_fsrR;
    
    /*
    fsrL = 0.6*fsrL + 0.4*_fsrL;
    fsrR = 0.6*fsrR + 0.4*_fsrR;
    */
    
    fsr = (fsrR - fsrL);
    
   
   //--------- MUSCLE LEN --------------------------------

    thetaL_r = (double)thetaL*340/1024 * GRAD2RAD;
    lenxL = dx - b*cos(beta_r - thetaL_r);
    lenyL = dy + b*sin(beta_r - thetaL_r);
    lenL = sqrt(pow(lenxL,2)+pow(lenyL,2));
    //lenL += -0.193;
    lenL += - 0.210 - 0.008 - 0.030;

    thetaR_r = (double)thetaR*340/1024 * GRAD2RAD;
    lenxR = dx + 0.002 - b*cos(beta_r - thetaR_r);//TODO
    lenyR = dy + b*sin(beta_r - thetaR_r);
    lenR = sqrt(pow(lenxR,2)+pow(lenyR,2));
    lenR += -0.022;
    lenR += - 0.210;

    //--------- DYNAMIC COMPENSATION -------------------

    fsrAidL = 100*tune0*(abs(fsr));
    fsrAidR = 100*tune1*(abs(fsr));
    
    gravL = (thetaL>0)?tune2*150*sin(thetaL_r):0;
    gravR = (thetaR>0)?tune3*150*sin(thetaR_r):0;
    
    
    
    Machine();// set of tauL_ref and tauR_ref
    
    //riferimenti a scalino e sinusoidale
    //tauL_ref = stairs(triang(time*10,100),10);
    //tauL_ref = 50*sin(_2PI*0.1*time*log(time)) + 100;
    
    //manuale con potenziometri
    //tauL_ref = 100*tune0;
    //tauR_ref = 100*tune1;
    
    
    //manuale con FSR
    //tauL_ref = 10* fsr2L.getNormalized();
    //tauR_ref = 10* fsr2R.getNormalized();
    
    tauL_ref++;
    gammaL_r = atan(lenyL/lenxL);//radians
    forceL_ref = tauL_ref / (b*sin(beta_r - thetaL_r + gammaL_r));
    
    
    tauR_ref++;
    gammaR_r = atan(lenyR/lenxR);//radians
    forceR_ref = tauR_ref / (b*sin(beta_r - thetaR_r + gammaR_r));
    
    tauL = forceL * (b*sin(beta_r - thetaL_r + gammaL_r));
    tauR = forceR * (b*sin(beta_r - thetaR_r + gammaR_r));
    
    //------------ MODEL -----------------------------------
   
    pressureL_model = Nn(lenL,forceL_ref);
    pressureR_model = Nn(lenR,forceR_ref);

    //-------------- CONTROL -------------------------------

    pressureL_ref = forcePidL() + pressureL_model;
    pressureR_ref = forcePidR() + pressureR_model;

    //pressureL_ref = 1000*tune0;
    //pressureR_ref = 1000*tune0;
    //-------------- OUTPUT --------------------------

    //saturation of the output
    windupL = 1;
    if(pressureL_ref<0) pressureL_ref = 0;
    else if(pressureL_ref>512) pressureL_ref = 512; //cause now we have only 5v over 10v
    else windupL= 0;
    
    windupR = 1;
    if(pressureR_ref<0) pressureR_ref = 0;
    else if(pressureR_ref>512) pressureR_ref = 512; //cause now we have only 5v over 10v
    else windupR= 0;

    //write pwm out value
    outL = map(pressureL_ref, 0, 1023, 0, 255);
    outR = map(pressureR_ref, 0, 1023, 0, 255);
    
    analogWrite(12, outL);
    analogWrite(13, outR);
  }
  
  //serial comunication
  serial();
  
  //rtc
  time += Ts;
}      



