#include <nnp2.h>
#define nn3


#define TOMMY
//#define MATLAB
//#define SERIAL_LEFT
//#define SERIAL_RIGHT
//#define SERIAL_FSR
//#define SERIAL_WALK

//#define   FSR_MONITOR

#define MAXINT 32767
#define _2PI 6.2832
#define _PI 3.1416
#define GRAD2RAD 0.0175

//al momento il task comprensivo di comunicazione matlab impiega 2 cicli di timer a 60Hz (30Hz)
#define PROC_DURATION 2

// These constants won't change. They're used to give names
// to the pins used:
const int anInPin0 = 0; 
const int anInPin1 = 1; 
const int anInPin2 = 2; 
const int anInPin3 = 3; 
const int anInPin4 = 4; 
const int anInPin5 = 5; 
const int anInPin6 = 6; 
const int anInPin7 = 7; 
const int anInPin8 = 8;
const int anInPin9 = 9;
const int anInPin10 = 10;
const int anInPin11 = 11;
const int anInPin12 = 12;
const int anInPin13 = 13;
const int anInPin14 = 14;
const int anInPin15 = 15;

int anValue[16];// values read from the pins 0 to 7

//system frequency / sampling time
double Fs;
double Ts;

//physics

//mechanical constants
//const double beta_r = 60 * GRAD2RAD;
//const double beta_r = 77 * GRAD2RAD;
//const double beta_r = 85 * GRAD2RAD;
const double beta_r = 41 * GRAD2RAD;
const double b = 0.075;
const double dx = 0.625;
//const double dy = 0.535;//cambia con l'altezza
const double dy = 0.483;//cambia con l'altezza


//Left
int thetaL = 0;
int dthetaL = 0;
int _thetaL = 0;
int thetaL_ref = 0;
int forceL = 0;
int pressureL = 0;
int pressureL_ref = 0;

double thetaL_r, gammaL_r;//radians
double forceL_ref = 0;// *50*9.81/1024 ->  newton 
double fsrAidL = 0;// *50*9.81/1024 ->  newton 
double tauL_ref = 0;// *50*9.81/1024 -> newton meter
double tauL = 0;
double gravL = 0;

double fsrL,dfsrL,_fsrL;
//double fsr1L,fsr2L,fsr3L;

//compute the lenght of muscle
double  lenxL, lenyL, lenL;
double pressureL_model;

//right
int thetaR = 0;
int dthetaR = 0;
int _thetaR = 0;
int thetaR_ref = 0;
int forceR = 0;
int pressureR = 0;
int pressureR_ref = 0;

double thetaR_r, gammaR_r;//radians
double forceR_ref = 0;// *50*9.81/1024 ->  newton 
double fsrAidR = 0;// *50*9.81/1024 ->  newton 
double tauR_ref = 0;// *50*9.81/1024 -> newton meter
double tauR = 0;
double gravR = 0;

double fsrR,dfsrR,_fsrR;
//double fsr1R,fsr2R,fsr3R;


//compute the lenght of muscle
double  lenxR, lenyR, lenR;
double pressureR_model;

double fsr;

//output
int outL,outR;
int windupL, windupR;
double tune0, tune1, tune2, tune3, tune4, tune5;

//isr
int timer_counter = 0;
// Aruino runs at 16 Mhz, so we have 62500 Overflows per second without a prescaler...
// 1/ (16000000 / 1024) = 1 / 62500
ISR(TIMER2_OVF_vect) {

  cli();
  timer_counter++;
  if (timer_counter == PROC_DURATION) 
  {
    process();
    timer_counter = 0;
  }
  sei();
  
};


void setup() {

  //---------------- PWM setup -----------------------
 
  pinMode(13, OUTPUT);  
  pinMode(12, OUTPUT); 

  //Setting prescaler on Timer0B (pwm4)
  //First clear all three prescaler bits:
  int prescalerVal = 0x07; //create a variable called prescalerVal and set it equal to the binary  number "00000111"
  TCCR0B &= ~prescalerVal; //AND the value in TCCR0B with binary number "11111000"
      
  //Now set the appropriate prescaler bits:
  int myPrescalerVal = 0x01; //set prescalerVal equal to binary number "00000001"
  TCCR0B |= myPrescalerVal; //OR the value in TCCR0B with binary number "00000001"

  //-------------- Process Triggering --------------
  //timer2A--->pwm10
  //timer2B--->pwm9
  //Timer2 Settings: Timer No Prescaler, WGM mode 0
  TCCR2A = 0;
  //TCCR2B = 0<<CS22 | 0<<CS21 | 1 << CS20;// 62500 Hz
  //TCCR2B = 0<<CS22 | 1<<CS21 | 0 << CS20;// 7812.5 Hz
  //TCCR2B = 0<<CS22 | 1<<CS21 | 1 << CS20;// 1953.125 Hz
  //TCCR2B = 1<<CS22 | 0<<CS21 | 0 << CS20;// 976.5625 Hz
  //TCCR2B = 1<<CS22 | 0<<CS21 | 1 << CS20;// 488.28125 Hz
  //TCCR2B = 1<<CS22 | 1<<CS21 | 0 << CS20;// 244.140625 Hz
  TCCR2B = 1<<CS22 | 1<<CS21 | 1 << CS20;// 61.03515625 Hz
  //Timer2 Overflow Interrupt Enable  
  //TIMSK2 = 1<<TOIE2;
  
  #define SYS_FREQ 61.03515625
  
  Fs = SYS_FREQ/PROC_DURATION;
  Ts = 1/Fs;

  //Timer2 Overflow Interrupt Enable
  TIMSK2 |= (1 << TOIE2);
  TCNT2 = 0;
  sei();

  GenerateNetwork();

  Serial.begin(19200);
  Serial1.begin(115200);

}

void loop()
{
}








